--- kern/vfs_syscalls.c.orig
+++ kern/vfs_syscalls.c
@@ -85,8 +85,10 @@
 static int setfflags(struct thread *td, struct vnode *, int);
 static int setutimes(struct thread *td, struct vnode *,
     const struct timespec *, int, int);
+static int kern_get_at(struct thread *td, int dirfd, struct vnode **dir_vn);
 static int vn_access(struct vnode *vp, int user_flags, struct ucred *cred,
     struct thread *td);
+static int kern_absolute_path(char *path, enum uio_seg pathseg);
 
 /*
  * The module initialization routine for POSIX asynchronous I/O will
@@ -953,10 +955,73 @@
 	return kern_open(td, uap->path, UIO_USERSPACE, uap->flags, uap->mode);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct openat_args {
+	int	fd;
+	char	*path;
+	int	flag;
+	int	mode;
+};
+#endif
 int
+openat(struct thread *td, struct openat_args *args)
+{
+	return kern_openat(td, args->path, UIO_USERSPACE, args->flag,
+	    args->mode, args->fd);
+}
+
+int
 kern_open(struct thread *td, char *path, enum uio_seg pathseg, int flags,
     int mode)
 {
+	return kern_openat(td, path, pathseg, flags, mode, AT_FDCWD);
+}
+
+static int
+kern_get_at(struct thread *td, int dirfd, struct vnode **dir_vn)
+{
+	int error;
+
+	if (dirfd == AT_FDCWD)
+		*dir_vn = NULL;
+	else {
+		error = fgetvp(td, dirfd, dir_vn);
+		if (error) {
+		   	*dir_vn = NULL;
+			return (error);
+		}
+		if ((*dir_vn)->v_type != VDIR) {
+			vrele(*dir_vn);
+			*dir_vn = NULL;
+			return (ENOTDIR);
+		}
+	}
+
+	return (0);
+}
+
+/* Check whether a path is an absolute path. */
+static int kern_absolute_path(char *path, enum uio_seg pathseg)
+{
+	int error;
+	char buf[1];
+
+	if (pathseg == UIO_SYSSPACE) {
+		return (path[0] == '/');		
+	} else {
+		error = copyin(path, buf, 1);
+		if (error)
+			return 0;	/* we want to fail */
+		return (buf[0] == '/');	
+	}
+}
+
+int
+kern_openat(struct thread *td, char *path, enum uio_seg pathseg, int flags,
+    int mode, int dirfd)
+{
+	struct nameidata nd;
+	struct vnode *dir_vn;
 	struct proc *p = td->td_proc;
 	struct filedesc *fdp = p->p_fd;
 	struct file *fp;
@@ -967,23 +1032,33 @@
 	struct file *nfp;
 	int type, indx, error;
 	struct flock lf;
-	struct nameidata nd;
 	int vfslocked;
 
 	AUDIT_ARG(fflags, flags);
 	AUDIT_ARG(mode, mode);
-	if ((flags & O_ACCMODE) == O_ACCMODE)
-		return (EINVAL);
+	/* XXX: audit dirfd */
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | AUDITVNODE1 |
+	    MPSAFE, pathseg, path, td, dir_vn);
+
+	if ((flags & O_ACCMODE) == O_ACCMODE) {
+		error = EINVAL;
+		goto out;
+	}
 	flags = FFLAGS(flags);
+
 	error = falloc(td, &nfp, &indx);
 	if (error)
-		return (error);
+		goto out;
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	fp = nfp;
 	cmode = ((mode &~ fdp->fd_cmask) & ALLPERMS) &~ S_ISTXT;
-	NDINIT(&nd, LOOKUP, FOLLOW | AUDITVNODE1 | MPSAFE, pathseg, path, td);
 	td->td_dupfd = -1;		/* XXX check for fdopen */
- 	error = vn_open(&nd, &flags, cmode, fp);
+	error = vn_open(&nd, &flags, cmode, fp);
 	if (error) {
 		/*
 		 * If the vn_open replaced the method vector, something
@@ -993,7 +1068,8 @@
 		if (error == ENXIO && fp->f_ops != &badfileops) {
 			fdrop(fp, td);
 			td->td_retval[0] = indx;
-			return (0);
+			error = 0;
+			goto out;
 		}
 
 		/*
@@ -1007,7 +1083,8 @@
 			dupfdopen(td, fdp, indx, td->td_dupfd, flags, error)) == 0) {
 			td->td_retval[0] = indx;
 			fdrop(fp, td);
-			return (0);
+			error = 0;
+			goto out;
 		}
 		/*
 		 * Clean up the descriptor, but only if another thread hadn't
@@ -1018,7 +1095,7 @@
 
 		if (error == ERESTART)
 			error = EINTR;
-		return (error);
+		goto out;
 	}
 	td->td_dupfd = 0;
 	vfslocked = NDHASGIANT(&nd);
@@ -1078,10 +1155,16 @@
 	fdrop(fp, td);
 	td->td_retval[0] = indx;
 	return (0);
+out:
+	if (dir_vn)
+		vrele(dir_vn);
+	return (error);
 bad:
 	VFS_UNLOCK_GIANT(vfslocked);
 	fdclose(fdp, fp, indx, td);
 	fdrop(fp, td);
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -1132,11 +1215,32 @@
 	return (kern_mknod(td, uap->path, UIO_USERSPACE, uap->mode, uap->dev));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct mknodat_args {
+	char	*path;
+	mode_t	mode;
+	dev_t	dev;
+};
+#endif
 int
+mknodat(struct thread *td, struct mknodat_args *args)
+{
+	return kern_mknodat(td, args->path, UIO_USERSPACE, args->mode,
+	    args->dev, args->fd);
+}
+
+int
 kern_mknod(struct thread *td, char *path, enum uio_seg pathseg, int mode,
     int dev)
 {
-	struct vnode *vp;
+	return kern_mknodat(td, path, pathseg, mode, dev, AT_FDCWD);
+}
+
+int
+kern_mknodat(struct thread *td, char *path, enum uio_seg pathseg, int mode,
+    int dev, int dirfd)
+{
+	struct vnode *vp, *dir_vn = NULL;
 	struct mount *mp;
 	struct vattr vattr;
 	int error;
@@ -1164,11 +1268,19 @@
 	if (error)
 		return (error);
 restart:
+	if (dir_vn)
+		vrele(dir_vn);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
+	if ((error = namei(&nd)) != 0) {
+		if (dir_vn)
+			vrele(dir_vn);
 		return (error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	if (vp != NULL) {
@@ -1179,6 +1291,8 @@
 			vput(nd.ni_dvp);
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
+		if (dir_vn)
+			vrele(dir_vn);
 		return (EEXIST);
 	} else {
 		VATTR_NULL(&vattr);
@@ -1210,8 +1324,11 @@
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vput(nd.ni_dvp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0)
+		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0) {
+			if (dir_vn)
+				vrele(dir_vn);
 			return (error);
+		}
 		goto restart;
 	}
 #ifdef MAC
@@ -1230,6 +1347,8 @@
 				vput(nd.ni_vp);
 		}
 	}
+	if (dir_vn)
+		vrele(dir_vn);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
 	vn_finished_write(mp);
@@ -1258,22 +1377,51 @@
 	return (kern_mkfifo(td, uap->path, UIO_USERSPACE, uap->mode));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct mkfifoat_args {
+	int	fd;
+	char	*path;
+	mode_t	mode;
+};
+#endif
+int
+mkfifoat(struct thread *td, struct mkfifoat_args *args)
+{
+	return kern_mkfifoat(td, args->path, UIO_USERSPACE, args->mode, args->fd);
+}
+
 int
 kern_mkfifo(struct thread *td, char *path, enum uio_seg pathseg, int mode)
 {
+	return kern_mkfifoat(td, path, pathseg, mode, AT_FDCWD);
+}
+
+int
+kern_mkfifoat(struct thread *td, char *path, enum uio_seg pathseg, int mode,
+    int dirfd)
+{
 	struct mount *mp;
 	struct vattr vattr;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dir_vn = NULL;
 
 	AUDIT_ARG(mode, mode);
 restart:
+	if (dir_vn)
+		vrele(dir_vn);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
+	if ((error = namei(&nd)) != 0) {
+		if (dir_vn)
+			vrele(dir_vn);
 		return (error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	if (nd.ni_vp != NULL) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
@@ -1283,14 +1431,19 @@
 			vput(nd.ni_dvp);
 		vrele(nd.ni_vp);
 		VFS_UNLOCK_GIANT(vfslocked);
+		if (dir_vn)
+			vrele(dir_vn);
 		return (EEXIST);
 	}
 	if (vn_start_write(nd.ni_dvp, &mp, V_NOWAIT) != 0) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vput(nd.ni_dvp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0)
+		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0) {
+			if (dir_vn)
+				vrele(dir_vn);
 			return (error);
+	}
 		goto restart;
 	}
 	VATTR_NULL(&vattr);
@@ -1311,6 +1464,8 @@
 #ifdef MAC
 out:
 #endif
+	if (dir_vn)
+		vrele(dir_vn);
 	vput(nd.ni_dvp);
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
@@ -1341,6 +1496,29 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct linkat_args {
+   	int	fd1;
+	char	*path1;
+	int	fd2;
+	char	*path2;
+	int	flag;
+};
+#endif
+int
+linkat(struct thread *td, struct linkat_args *args)
+{
+   	if (args->flag & ~AT_SYMLINK_FOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_FOLLOW)
+		return kern_linkat(td, args->path1, args->path2,
+		    UIO_USERSPACE, args->fd1, args->fd2, FOLLOW);
+	else
+		return kern_linkat(td, args->path1, args->path2,
+		    UIO_USERSPACE, args->fd1, args->fd2, 0);
+}
+
 static int hardlink_check_uid = 0;
 SYSCTL_INT(_security_bsd, OID_AUTO, hardlink_check_uid, CTLFLAG_RW,
     &hardlink_check_uid, 0,
@@ -1383,62 +1561,88 @@
 int
 kern_link(struct thread *td, char *path, char *link, enum uio_seg segflg)
 {
+	return kern_linkat(td, path, link, segflg, AT_FDCWD, AT_FDCWD, FOLLOW);
+}
+
+int
+kern_linkat(struct thread *td, char *path, char *link, enum uio_seg segflg,
+    int olddirfd, int newdirfd, int follow)
+{
+	struct nameidata ndp, ndl;
+	int error;
+	struct vnode *pdir_vn, *ldir_vn;
 	struct vnode *vp;
 	struct mount *mp;
-	struct nameidata nd;
 	int vfslocked;
 	int lvfslocked;
-	int error;
+
+	error = kern_get_at(td, olddirfd, &pdir_vn);
+	if (error && !kern_absolute_path(path, segflg))
+		return (error);
+
+	NDINIT_AT(&ndp, LOOKUP, ((error) ? ATBADF : 0) | follow | MPSAFE |
+	    AUDITVNODE1, segflg, path, td, pdir_vn);
+
+	error = kern_get_at(td, newdirfd, &ldir_vn);
+	if (error && !kern_absolute_path(link, segflg))
+		return (error);
+
+	NDINIT_AT(&ndl, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, segflg, link, td, ldir_vn);
 
 	bwillwrite();
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, segflg, path, td);
-	if ((error = namei(&nd)) != 0)
-		return (error);
-	vfslocked = NDHASGIANT(&nd);
-	NDFREE(&nd, NDF_ONLY_PNBUF);
-	vp = nd.ni_vp;
+	if ((error = namei(&ndp)) != 0)
+		goto out;
+	vfslocked = NDHASGIANT(&ndp);
+	NDFREE(&ndp, NDF_ONLY_PNBUF);
+	vp = ndp.ni_vp;
 	if (vp->v_type == VDIR) {
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (EPERM);		/* POSIX */
+		error = EPERM;		/* POSIX */
+		goto out;
 	}
 	if ((error = vn_start_write(vp, &mp, V_WAIT | PCATCH)) != 0) {
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (error);
+		goto out;
 	}
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE2,
-	    segflg, link, td);
-	if ((error = namei(&nd)) == 0) {
-		lvfslocked = NDHASGIANT(&nd);
-		if (nd.ni_vp != NULL) {
-			if (nd.ni_dvp == nd.ni_vp)
-				vrele(nd.ni_dvp);
+	if ((error = namei(&ndl)) == 0) {
+		lvfslocked = NDHASGIANT(&ndl);
+		if (ndl.ni_vp != NULL) {
+			if (ndl.ni_dvp == ndl.ni_vp)
+				vrele(ndl.ni_dvp);
 			else
-				vput(nd.ni_dvp);
-			vrele(nd.ni_vp);
+				vput(ndl.ni_dvp);
+			vrele(ndl.ni_vp);
 			error = EEXIST;
 		} else if ((error = vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td))
 		    == 0) {
-			VOP_LEASE(nd.ni_dvp, td, td->td_ucred, LEASE_WRITE);
+			VOP_LEASE(ndl.ni_dvp, td, td->td_ucred, LEASE_WRITE);
 			VOP_LEASE(vp, td, td->td_ucred, LEASE_WRITE);
 			error = can_hardlink(vp, td, td->td_ucred);
 			if (error == 0)
 #ifdef MAC
 				error = mac_check_vnode_link(td->td_ucred,
-				    nd.ni_dvp, vp, &nd.ni_cnd);
+				    ndl.ni_dvp, vp, &ndl.ni_cnd);
 			if (error == 0)
 #endif
-				error = VOP_LINK(nd.ni_dvp, vp, &nd.ni_cnd);
+				error = VOP_LINK(ndl.ni_dvp, vp, &ndl.ni_cnd);
 			VOP_UNLOCK(vp, 0, td);
-			vput(nd.ni_dvp);
+			vput(ndl.ni_dvp);
 		}
-		NDFREE(&nd, NDF_ONLY_PNBUF);
+		NDFREE(&ndl, NDF_ONLY_PNBUF);
 		VFS_UNLOCK_GIANT(lvfslocked);
 	}
 	vrele(vp);
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
+
+out:
+	if (pdir_vn)
+		vrele(pdir_vn);
+	if (ldir_vn)
+		vrele(ldir_vn);
 	return (error);
 }
 
@@ -1463,15 +1667,36 @@
 	return (kern_symlink(td, uap->path, uap->link, UIO_USERSPACE));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct symlinkat_args {
+	char	*path;
+	int	fd;
+	char	*path2;
+};
+#endif
+int
+symlinkat(struct thread *td, struct symlinkat_args *args)
+{
+	return kern_symlinkat(td, args->path1, args->path2, UIO_USERSPACE, args->fd);
+}
+
 int
 kern_symlink(struct thread *td, char *path, char *link, enum uio_seg segflg)
 {
+	return kern_symlinkat(td, path, link, segflg, AT_FDCWD);
+}
+
+int
+kern_symlinkat(struct thread *td, char *path, char *link, enum uio_seg segflg,
+    int dirfd)
+{
 	struct mount *mp;
 	struct vattr vattr;
 	char *syspath;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dir_vn = NULL;
 
 	if (segflg == UIO_SYSSPACE) {
 		syspath = path;
@@ -1482,9 +1707,14 @@
 	}
 	AUDIT_ARG(text, syspath);
 restart:
+	if (dir_vn)
+		vrele(dir_vn);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(link, segflg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    segflg, link, td);
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, segflg, link, td, dir_vn);
 	if ((error = namei(&nd)) != 0)
 		goto out;
 	vfslocked = NDHASGIANT(&nd);
@@ -1530,6 +1760,8 @@
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
 out:
+	if (dir_vn)
+		vrele(dir_vn);
 	if (segflg != UIO_SYSSPACE)
 		uma_zfree(namei_zone, syspath);
 	return (error);
@@ -1608,21 +1840,54 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct unlinkat_args {
+	int	fd;
+	char	*path;
+	int	flag;
+};
+#endif
+int
+unlinkat(struct thread *td, struct unlinkat_args *args)
+{
+	if (args->flag & ~AT_REMOVEDIR)
+		return (EINVAL);
+
+	if (args->flag & AT_REMOVEDIR)
+		return kern_rmdirat(td, args->path, UIO_USERSPACE, args->fd);
+	else
+		return kern_unlinkat(td, args->path, UIO_USERSPACE, args->fd);
+}
+
 int
 kern_unlink(struct thread *td, char *path, enum uio_seg pathseg)
 {
+	return kern_unlinkat(td, path, pathseg, AT_FDCWD);
+}
+
+int
+kern_unlinkat(struct thread *td, char *path, enum uio_seg pathseg, int dirfd)
+{
 	struct mount *mp;
-	struct vnode *vp;
+	struct vnode *vp, *dir_vn = NULL;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
-
+	
 restart:
+	if (dir_vn)
+		vrele(dir_vn);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, DELETE, LOCKPARENT | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, DELETE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    LOCKLEAF | MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
+	if ((error = namei(&nd)) != 0) {
+		if (dir_vn)
+			vrele(dir_vn);		
 		return (error == EINVAL ? EPERM : error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	if (vp->v_type == VDIR)
@@ -1646,8 +1911,11 @@
 				vput(vp);
 			VFS_UNLOCK_GIANT(vfslocked);
 			if ((error = vn_start_write(NULL, &mp,
-			    V_XSLEEP | PCATCH)) != 0)
+			    V_XSLEEP | PCATCH)) != 0) {
+				if (dir_vn)
+					vrele(dir_vn);
 				return (error);
+			}
 			goto restart;
 		}
 #ifdef MAC
@@ -1665,6 +1933,8 @@
 	}
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
+	if (dir_vn)
+		vrele(dir_vn);
 	if (vp == nd.ni_dvp)
 		vrele(vp);
 	else
@@ -1849,14 +2119,44 @@
 	return (kern_access(td, uap->path, UIO_USERSPACE, uap->flags));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct faccessat_args {
+	int	dirfd;
+	char	*path;
+	int	mode;
+	int	flag;
+}
+#endif
+int faccessat(struct thread *td, struct faccessat_args *args)
+{
+	if (args->flag & ~AT_EACCESS)
+		return (EINVAL);
+	/* XXX: what about mode? */
+	return kern_accessat(td, args->path, UIO_USERSPACE, args->flag, args->dirfd);
+}
+
 int
 kern_access(struct thread *td, char *path, enum uio_seg pathseg, int flags)
 {
+	return kern_accessat(td, path, pathseg, flags, AT_FDCWD);
+}
+
+int
+kern_accessat(struct thread *td, char *path, enum uio_seg pathseg, int flags, int dirfd)
+{
+	int error;
+	struct nameidata nd;
+	struct vnode *dir_vn;
 	struct ucred *cred, *tmpcred;
-	register struct vnode *vp;
-	struct nameidata nd;
+	struct vnode *vp;
 	int vfslocked;
-	int error;
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | LOCKLEAF |
+	    MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
 
 	/*
 	 * Create and modify a temporary credential instead of one that
@@ -1865,13 +2165,16 @@
 	 */
 	cred = td->td_ucred;
 	tmpcred = crdup(cred);
-	tmpcred->cr_uid = cred->cr_ruid;
-	tmpcred->cr_groups[0] = cred->cr_rgid;
+	if (flags & AT_EACCESS) {
+		tmpcred->cr_uid = cred->cr_uid;
+		tmpcred->cr_groups[0] = cred->cr_groups[0];
+	} else {
+		tmpcred->cr_uid = cred->cr_ruid;
+		tmpcred->cr_groups[0] = cred->cr_rgid;
+	}
 	td->td_ucred = tmpcred;
-	NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		goto out1;
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 
@@ -1879,9 +2182,11 @@
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
-out1:
+out:
 	td->td_ucred = cred;
 	crfree(tmpcred);
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -2042,29 +2347,67 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct fstatat_args {
+	int	fd;
+	char	*path;
+	struct stat	*buf;
+	int	flag;
+}
+#endif
 int
+fstatat(struct thread *td, struct fstatat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return kern_lstatat(td, args->path, UIO_USERSPACE, args->buf, args->fd);
+	else
+		return kern_statat(td, args->path, UIO_USERSPACE, args->buf, args->fd);
+}
+
+int
 kern_stat(struct thread *td, char *path, enum uio_seg pathseg, struct stat *sbp)
 {
+	return kern_statat(td, path, pathseg, sbp, AT_FDCWD);
+}
+
+int
+kern_statat(struct thread *td, char *path, enum uio_seg pathseg,
+    struct stat *sbp, int dirfd)
+{
 	struct nameidata nd;
+	struct vnode *dir_vn;
 	struct stat sb;
 	int error, vfslocked;
 
-	NDINIT(&nd, LOOKUP,
-	    FOLLOW | LOCKSHARED | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | LOCKSHARED |
+	    LOCKLEAF | AUDITVNODE1 | MPSAFE, pathseg, path, td, dir_vn);
+
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	error = vn_stat(nd.ni_vp, &sb, td->td_ucred, NOCRED, td);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+	/* dont bother with the path as this is hopefully going away soon */
 	if (mtx_owned(&Giant))
-		printf("stat(%d): %s\n", vfslocked, path);
+		printf("stat(%d):\n", vfslocked);
 	if (error)
-		return (error);
+		goto out;
 	*sbp = sb;
-	return (0);
+
+	error = 0;
+out:	
+	if (dir_vn)
+		vrele(dir_vn);
+	return (error);
 }
 
 /*
@@ -2096,16 +2439,28 @@
 int
 kern_lstat(struct thread *td, char *path, enum uio_seg pathseg, struct stat *sbp)
 {
+	return kern_lstatat(td, path, pathseg, sbp, AT_FDCWD);
+}
+
+int
+kern_lstatat(struct thread *td, char *path, enum uio_seg pathseg,
+    struct stat *sbp, int dirfd)
+{
+	struct nameidata nd;
+	struct vnode *dir_vn;
 	struct vnode *vp;
 	struct stat sb;
-	struct nameidata nd;
 	int error, vfslocked;
 
-	NDINIT(&nd, LOOKUP,
-	    NOFOLLOW | LOCKLEAF | LOCKSHARED | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | LOCKLEAF |
+	    LOCKSHARED | AUDITVNODE1 | MPSAFE, pathseg, path, td, dir_vn);
+
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	error = vn_stat(vp, &sb, td->td_ucred, NOCRED, td);
@@ -2113,9 +2468,13 @@
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
 	if (error)
-		return (error);
+		goto out;
 	*sbp = sb;
-	return (0);
+	error = 0;
+out:	
+	if (dir_vn)
+		vrele(dir_vn);
+	return (error);
 }
 
 /*
@@ -2267,22 +2626,48 @@
 	return (kern_readlink(td, uap->path, UIO_USERSPACE, uap->buf,
 	    UIO_USERSPACE, uap->count));
 }
+#ifndef _SYS_SYSPROTO_H_
+struct readlinkat_args {
+	int	fd;
+	char	*path;
+	char	*buf;
+	size_t	bufsize;
+};
+#endif
+ssize_t
+readlinkat(struct thread *td, struct readlinkat_args *args)
+{
+	return kern_readlinkat(td, args->path, UIO_USERSPACE,
+	    args->buf, UIO_USERSPACE, args->bufsize, args->fd);
+}
 
 int
 kern_readlink(struct thread *td, char *path, enum uio_seg pathseg, char *buf,
     enum uio_seg bufseg, int count)
 {
-	register struct vnode *vp;
+	return kern_readlinkat(td, path, pathseg, buf, bufseg, count, AT_FDCWD);
+}
+
+int
+kern_readlinkat(struct thread *td, char *path, enum uio_seg pathseg, char *buf,
+    enum uio_seg bufseg, int count, int dirfd)
+{
+	struct nameidata nd;
+	struct vnode *dir_vn;
+	struct vnode *vp;
 	struct iovec aiov;
 	struct uio auio;
-	int error;
-	struct nameidata nd;
-	int vfslocked;
+	int error, vfslocked;
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | LOCKLEAF |
+	    MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
 
-	NDINIT(&nd, LOOKUP, NOFOLLOW | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
@@ -2291,7 +2676,7 @@
 	if (error) {
 		vput(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (error);
+		goto out;
 	}
 #endif
 	if (vp->v_type != VLNK)
@@ -2311,6 +2696,9 @@
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
 	td->td_retval[0] = count - auio.uio_resid;
+out:
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -2455,6 +2843,7 @@
 }
 
 /*
+ *
  * Common implementation code for chmod(), lchmod() and fchmod().
  */
 static int
@@ -2504,22 +2893,59 @@
 	return (kern_chmod(td, uap->path, UIO_USERSPACE, uap->mode));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct fchmodat_args {
+	int	dirfd;
+	char	*path;
+	mode_t	mode;
+	int	flag;
+}
+#endif
+int
+fchmodat(struct thread *td, struct fchmodat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return kern_lchmodat(td, args->path, UIO_USERSPACE,
+		    args->mode, args->dirfd);
+	else
+		return kern_chmodat(td, args->path, UIO_USERSPACE,
+		    args->mode, args->dirfd);
+}
+
 int
 kern_chmod(struct thread *td, char *path, enum uio_seg pathseg, int mode)
 {
-	int error;
+	return kern_chmodat(td, path, pathseg, mode, AT_FDCWD);
+}
+
+int
+kern_chmodat(struct thread *td, char *path, enum uio_seg pathseg,
+    mode_t mode, int dirfd)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dir_vn;
+	int error, vfslocked;
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dir_vn);
 
-	AUDIT_ARG(mode, mode);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfmode(td, nd.ni_vp, mode);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -2540,18 +2966,31 @@
 		int mode;
 	} */ *uap;
 {
+	return kern_lchmodat(td, uap->path, UIO_USERSPACE, uap->mode, AT_FDCWD);
+}
+
+
+int
+kern_lchmodat(struct thread *td, char *path, enum uio_seg pathseg,
+    mode_t mode, int dirfd)
+{
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dir_vn;
 
-	AUDIT_ARG(mode, (mode_t)uap->mode);
-	NDINIT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, UIO_USERSPACE,
-	    uap->path, td);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	AUDIT_ARG(mode, mode);
+	NDINIT_AT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, pathseg,
+	    path, td, dir_vn);
 	if ((error = namei(&nd)) != 0)
 		return (error);
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
-	error = setfmode(td, nd.ni_vp, uap->mode);
+	error = setfmode(td, nd.ni_vp, mode);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
 	return (error);
@@ -2649,23 +3088,54 @@
 	return (kern_chown(td, uap->path, UIO_USERSPACE, uap->uid, uap->gid));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+#endif
+int
+fchownat(struct thread *td, struct fchownat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return kern_lchownat(td, args->path, UIO_USERSPACE, args->uid,
+		    args->gid, args->dirfd);
+	else
+		return kern_chownat(td, args->path, UIO_USERSPACE, args->uid,
+		    args->gid, args->dirfd);
+}
+
 int
 kern_chown(struct thread *td, char *path, enum uio_seg pathseg, int uid,
     int gid)
 {
-	int error;
+	return kern_chownat(td, path, pathseg, uid, gid, AT_FDCWD);
+}
+
+int
+kern_chownat(struct thread *td, char *path, enum uio_seg pathseg, int uid,
+    int gid, int dirfd)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dir_vn;
+	int error, vfslocked;
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dir_vn);
 
-	AUDIT_ARG(owner, uid, gid);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfown(td, nd.ni_vp, uid, gid);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -2696,19 +3166,34 @@
 kern_lchown(struct thread *td, char *path, enum uio_seg pathseg, int uid,
     int gid)
 {
-	int error;
+	return kern_lchownat(td, path, pathseg, uid, gid, AT_FDCWD);
+}
+
+int
+kern_lchownat(struct thread *td, char *path, enum uio_seg pathseg, int uid,
+    int gid, int dirfd)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dir_vn;
+	int error, vfslocked;
+
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dir_vn);
 
-	AUDIT_ARG(owner, uid, gid);
-	NDINIT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfown(td, nd.ni_vp, uid, gid);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -2851,25 +3336,49 @@
 	    UIO_USERSPACE));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+#endif
+int
+futimesat(struct thread *td, struct futimesat_args *args)
+{
+	return kern_utimesat(td, args->path, UIO_USERSPACE, args->times, UIO_USERSPACE, args->fd);
+}
+
 int
 kern_utimes(struct thread *td, char *path, enum uio_seg pathseg,
     struct timeval *tptr, enum uio_seg tptrseg)
 {
+	return kern_utimesat(td, path, pathseg, tptr, tptrseg, AT_FDCWD);
+}
+
+int
+kern_utimesat(struct thread *td, char *path, enum uio_seg pathseg,
+    struct timeval *tptr, enum uio_seg tptrseg, int dirfd)
+{
+	struct nameidata nd;
+	struct vnode *dir_vn;
 	struct timespec ts[2];
-	int error;
-	struct nameidata nd;
-	int vfslocked;
+	int error, vfslocked;
+
+   	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | AUDITVNODE1 |
+	    MPSAFE, pathseg, path, td, dir_vn);
 
 	if ((error = getutimes(tptr, tptrseg, ts)) != 0)
-		return (error);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
+		goto out;
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setutimes(td, nd.ni_vp, ts, 2, tptr == NULL);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:
+	if (dir_vn)
+		vrele(dir_vn);
 	return (error);
 }
 
@@ -3217,26 +3726,60 @@
 	return (kern_rename(td, uap->from, uap->to, UIO_USERSPACE));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct renameat_args {
+	int	oldfd;
+	char	*old;
+	int	newfd;
+	char	*new;
+};
+#endif
 int
+renameat(struct thread *td, struct renameat_args *args)
+{
+	return kern_renameat(td, args->old, args->new, UIO_USERSPACE,
+	    args->oldfd, args->newfd);
+}
+
+int
 kern_rename(struct thread *td, char *from, char *to, enum uio_seg pathseg)
 {
+	return kern_renameat(td, from, to, pathseg, AT_FDCWD, AT_FDCWD);
+}
+
+int
+kern_renameat(struct thread *td, char *from, char *to, enum uio_seg pathseg,
+    int fdirfd, int tdirfd)
+{
+	struct nameidata fromnd, tond;
+	struct vnode *fdir_vn, *tdir_vn;
 	struct mount *mp = NULL;
 	struct vnode *tvp, *fvp, *tdvp;
-	struct nameidata fromnd, tond;
 	int tvfslocked;
 	int fvfslocked;
 	int error;
 
-	bwillwrite();
+	error = kern_get_at(td, fdirfd, &fdir_vn);
+	if (error && !kern_absolute_path(from, pathseg))
+		return (error);
+	error = kern_get_at(td, tdirfd, &tdir_vn);
+	if (error && !kern_absolute_path(to, pathseg))
+		return (error);
+
 #ifdef MAC
-	NDINIT(&fromnd, DELETE, LOCKPARENT | LOCKLEAF | SAVESTART | MPSAFE |
-	    AUDITVNODE1, pathseg, from, td);
+	NDINIT_AT(&fromnd, DELETE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    LOCKLEAF | SAVESTART | MPSAFE | AUDITVNODE1, pathseg, from, td, fdir_vn);
 #else
-	NDINIT(&fromnd, DELETE, WANTPARENT | SAVESTART | MPSAFE |
-	    AUDITVNODE1, pathseg, from, td);
+	NDINIT_AT(&fromnd, DELETE, ((error) ? ATBADF : 0) | WANTPARENT |
+	    SAVESTART | MPSAFE | AUDITVNODE1, pathseg, from, td, fdir_vn);
 #endif
+	NDINIT_AT(&tond, RENAME, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    LOCKLEAF | NOCACHE | SAVESTART | MPSAFE | AUDITVNODE2,
+	    pathseg, to, td, tdir_vn);
+
+	bwillwrite();
 	if ((error = namei(&fromnd)) != 0)
-		return (error);
+		goto out2;
 	fvfslocked = NDHASGIANT(&fromnd);
 	tvfslocked = 0;
 #ifdef MAC
@@ -3255,8 +3798,6 @@
 		vrele(fvp);
 		goto out1;
 	}
-	NDINIT(&tond, RENAME, LOCKPARENT | LOCKLEAF | NOCACHE | SAVESTART |
-	    MPSAFE | AUDITVNODE2, pathseg, to, td);
 	if (fromnd.ni_vp->v_type == VDIR)
 		tond.ni_cnd.cn_flags |= WILLBEDIR;
 	if ((error = namei(&tond)) != 0) {
@@ -3328,6 +3869,12 @@
 	VFS_UNLOCK_GIANT(tvfslocked);
 	if (error == -1)
 		return (0);
+out2:
+	if (fdir_vn)
+		vrele(fdir_vn);
+	if (tdir_vn)
+		vrele(tdir_vn);
+
 	return (error);
 }
 
@@ -3352,11 +3899,30 @@
 	return (kern_mkdir(td, uap->path, UIO_USERSPACE, uap->mode));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct mkdirat_args {
+	int	fd;
+	char	*path;
+	mode_t	mode;
+};
+#endif
+int
+mkdirat(struct thread *td, struct mkdirat_args *args)
+{
+	return kern_mkdirat(td, args->path, UIO_USERSPACE, args->mode, args->fd);
+}
+
 int
 kern_mkdir(struct thread *td, char *path, enum uio_seg segflg, int mode)
 {
+	return kern_mkdirat(td, path, segflg, mode, AT_FDCWD);
+}
+
+int
+kern_mkdirat(struct thread *td, char *path, enum uio_seg segflg, int mode, int dirfd)
+{
 	struct mount *mp;
-	struct vnode *vp;
+	struct vnode *vp, *dir_vn = NULL;
 	struct vattr vattr;
 	int error;
 	struct nameidata nd;
